<?php
/*
  $Id: cm_cp_points.php
  $Loc: catalog/includes/modules/content/checkout_payment/

   Version: 2.0
   originally coded by Ben Zukrel 
   Improved and converted for osC Bootstrap by
   @Tsimi
   and
   @raiwa Rainer Schmied / info@oscaddons.com  / www.oscaddons.com

   Additional credits to @LeeFoster for bug reports and fixes
   German translation by @Tsimi
   German revision by @raiwa
   Spanish translation by @TITO4
   Spanish revision by @PiLLaO 

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2018 osCommerce

  Released under the GNU General Public License
*/

  class cm_cp_points {
    var $version = '2.0';
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_TITLE;
      $this->description = MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_DESCRIPTION;
      $this->description .= '<div class="secWarning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';

      if ( defined('MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_STATUS == 'True');
      }
    }

    function execute() {
      global $oscTemplate, $cart, $order, $currencies, $points, $customer_shopping_points, $customer_shopping_points_spending, $customer_referred;
      
      $content_width = (int)MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_CONTENT_WIDTH;

      if ((MODULE_HEADER_TAGS_POINTS_REWARDS_USE_POINTS_SYSTEM == 'True') && (MODULE_HEADER_TAGS_POINTS_REWARDS_USE_REDEEM_SYSTEM == 'True')) {
        $cart_show_total= $cart->show_total();

      
        if ( tep_not_null($max_points = check_points_redemtion ($cart_show_total)) ) {
					$customer_shopping_points_to_spent = $max_points;
          $note = null;
          if ($order->info['total'] > tep_calc_shopping_pvalue($max_points)) {
            $note = '<br><small>' . MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_REDEEM_SYSTEM_NOTE .'</small>';
          }
        }
        
        // PWA guest checkout support BEGIN
        if ( defined('MODULE_CONTENT_PWA_LOGIN_STATUS') && MODULE_CONTENT_PWA_LOGIN_STATUS == 'True' && tep_session_is_registered('customer_is_guest') ) {
          $orders_check_query = tep_db_query("select count(*) as total from orders o, orders_status s where o.customers_email_address = '" . $order->customer['email_address'] . "'");
          $orders_check = tep_db_fetch_array($orders_check_query);
          $check_first_order = $orders_check['total'];
        } else {
          $check_first_order = tep_count_customer_orders();
        }
        // PWA guest checkout support END
        
        ob_start();
        include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
        $template = ob_get_clean();

        $oscTemplate->addContent($template, $this->group);
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ( 'Module Version', 'MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_VERSION', '" . $this->version . "', 'The version of this module that you are running', '6', '0', 'tep_cfg_disabled(', now() ) ");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Comments Module', 'MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_STATUS', 'True', 'Should this module be shown on the checkout payment page?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_CONTENT_WIDTH', '12', 'What width container should the content be shown in?', '6', '1', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_SORT_ORDER', '350', 'Sort order of display. Lowest is displayed first.', '6', '1', now())");
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_VERSION', 'MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_STATUS', 'MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_CONTENT_WIDTH', 'MODULE_CONTENT_CHECKOUT_PAYMENT_POINTS_SORT_ORDER');
    }
    
  } // end class
  
  ////
  // Function to show a disabled entry (Value is shown but cannot be changed)
  if( !function_exists( 'tep_cfg_disabled' ) ) {
    function tep_cfg_disabled( $value ) {
      return tep_draw_input_field( 'configuration_value', $value, ' disabled' );
    }
  }
