<?php
/*
  $Id: cm_sc_points_redeem.php 
  $Loc: catalog/includes/modules/content/shopping_cart/
  
   Version: 2.0.1.
   originally coded by Ben Zukrel 
   Improved and converted for osC Bootstrap by
   @Tsimi
   and
   @raiwa Rainer Schmied / info@oscaddons.com  / www.oscaddons.com

   Additional credits to @LeeFoster for bug reports and fixes
   German translation by @Tsimi
   German revision by @raiwa
   Spanish translation by @TITO4
   Spanish revision by @PiLLaO 
  
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2017 osCommerce

  Released under the GNU General Public License
*/


  class cm_sc_points_redeem {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_SC_POINTS_REDEEM_TITLE;
      $this->description = MODULE_CONTENT_SC_POINTS_REDEEM_DESCRIPTION;
      $this->description .= '<div class="secWarning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';

      if ( defined('MODULE_CONTENT_SC_POINTS_REDEEM_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_SC_POINTS_REDEEM_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_SC_POINTS_REDEEM_STATUS == 'True');
      }
    }

    function execute() {
      global $oscTemplate, $cart, $currencies, $order, $language, $customer_shopping_points, $customer_shopping_points_spending, $customer_referred;

      $content_width = (int)MODULE_CONTENT_SC_POINTS_REDEEM_CONTENT_WIDTH;
      
      if ( ($cart->count_contents() > 0) && (MODULE_HEADER_TAGS_POINTS_REWARDS_USE_POINTS_SYSTEM == 'True') && (MODULE_HEADER_TAGS_POINTS_REWARDS_USE_REDEEM_SYSTEM == 'True')) {

        require_once('includes/functions/redemptions.php');
    
        $cart_show_total = $cart->show_total();
        
        // PWA guest checkout support BEGIN
        if ( defined('MODULE_CONTENT_PWA_LOGIN_STATUS') && MODULE_CONTENT_PWA_LOGIN_STATUS == 'True' && tep_session_is_registered('customer_is_guest') ) {
          $orders_check_query = tep_db_query("select count(*) as total from orders o, orders_status s where o.customers_email_address = '" . $order->customer['email_address'] . "'");
          $orders_check = tep_db_fetch_array($orders_check_query);
          $check_first_order = $orders_check['total'];
        } else {
          $check_first_order = tep_count_customer_orders();
        }
        // PWA guest checkout support END
        
        $points_redeem_output = null;
        $points_referral_output = null;
        $note = null;
        $customer_shopping_points_to_spent = null;
        if (tep_session_is_registered('customer_id')) {
          if ( tep_not_null($max_points = check_points_redemtion ($cart_show_total)) || isset($customer_shopping_points_spending) ) {
            $points_redeem_output .= tep_draw_form('points', tep_href_link('shopping_cart.php'), 'post');
            $customer_shopping_points_to_spent = $max_points;
            if ($order->info['total'] > tep_calc_shopping_pvalue($max_points)) {
              $note = '<br><small>' . MODULE_CONTENT_SC_POINTS_REDEEM_NOTE .'</small>';
              $points_redeem_output .= '    <div class="col-sm-9">';
              $points_redeem_output .= sprintf(MODULE_CONTENT_SC_POINTS_REDEEM_START, $currencies->format(tep_calc_shopping_pvalue($customer_shopping_points)), $currencies->format($order->info['total']). $note) . '<br>';
              $points_redeem_output .= sprintf(MODULE_CONTENT_SC_POINTS_REDEEM_SPENDING, number_format($max_points,MODULE_HEADER_TAGS_POINTS_REWARDS_POINTS_POINTS_DECIMAL_PLACES), '/&nbsp;' . $currencies->format(tep_calc_shopping_pvalue($max_points)));
              $points_redeem_output .= '&nbsp;&nbsp;<i class="fa fa-arrow-right"></i>&nbsp;&nbsp;' . tep_draw_checkbox_field('customer_shopping_points_input', $customer_shopping_points_to_spent, isset($customer_shopping_points_spending));
              $points_redeem_output .= '    </div>';	
              $points_redeem_output .= '    <div class="col-sm-3">';
              $points_redeem_output .= tep_draw_button(MODULE_CONTENT_SC_POINTS_REDEEM_IMAGE_BUTTON_APPLY, 'fas fa-sync') . tep_draw_hidden_field('points_action', 'update_points');
              $points_redeem_output .= '    </div>';
            } else {
              $customer_shopping_points_to_spent = isset($customer_shopping_points_spending)? $customer_shopping_points_spending : $max_points;
              $points_redeem_output .= '    <div class="col-sm-9">';
              $points_redeem_output .= sprintf(MODULE_CONTENT_SC_POINTS_REDEEM_START, $currencies->format(tep_calc_shopping_pvalue($customer_shopping_points)), $currencies->format(tep_calc_shopping_pvalue($customer_shopping_points_to_spent)). $note) . '<br>';
              $points_redeem_output .= sprintf(MODULE_CONTENT_SC_POINTS_REDEEM_PAYING, number_format($customer_shopping_points_to_spent, MODULE_HEADER_TAGS_POINTS_REWARDS_POINTS_POINTS_DECIMAL_PLACES), '/&nbsp;' . $currencies->format(tep_calc_shopping_pvalue($customer_shopping_points_to_spent)));
              $points_redeem_output .= '&nbsp;&nbsp;<i class="fa fa-arrow-right"></i>&nbsp;&nbsp;' . tep_draw_checkbox_field('customer_shopping_points_input', $customer_shopping_points_to_spent, isset($customer_shopping_points_spending));
              $points_redeem_output .= '    </div>';	
              $points_redeem_output .= '    <div class="col-sm-3">';
              $points_redeem_output .= tep_draw_button(MODULE_CONTENT_SC_POINTS_REDEEM_IMAGE_BUTTON_APPLY, 'fas fa-sync') . tep_draw_hidden_field('points_action', 'update_points');
              $points_redeem_output .= '    </div>';
            }
            $points_redeem_output .= '  </form>';
          }

          if (tep_not_null(MODULE_HEADER_TAGS_POINTS_REWARDS_POINTS_USE_REFERRAL_SYSTEM) && ($check_first_order == 0)) {
            $points_referral_output .= tep_draw_form('referral', tep_href_link('shopping_cart.php'), 'post');
            $points_referral_output .= '    <div class="col-sm-9">';
            $points_referral_output .= MODULE_CONTENT_SC_POINTS_REDEEM_REFERRAL_REFERRED;
            $points_referral_output .= tep_draw_input_field('customer_referred_input', ((isset($customer_referred))? $customer_referred : ''), 'style="width:250px;"');
            $points_referral_output .= '    </div>';	
            $points_referral_output .= '    <div class="col-sm-3">';
            $points_referral_output .= tep_draw_button(MODULE_CONTENT_SC_POINTS_REDEEM_IMAGE_BUTTON_APPLY, 'fas fa-sync') . tep_draw_hidden_field('points_action', 'update_referral');
            $points_referral_output .= '    </div>';
            $points_referral_output .= '  </form>';
          }
        } else {		       
          $points_redeem_output .= '     <div class="col-sm-12"><p>' . MODULE_CONTENT_SC_POINTS_REDEEM_TEXT_LOG_IN . '</p></div>';
          $points_redeem_output .= '     <div class="col-sm-12">' . tep_draw_button(MODULE_CONTENT_SC_POINTS_REDEEM_IMAGE_BUTTON_LOG_IN, 'glyphicon glyphicon-log-in', tep_href_link('login.php'), 'btn-success btn-sm') . '</div>';
        }
          
       
        ob_start();
          include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
          $template = ob_get_clean();

          $oscTemplate->addContent($template, $this->group);
      }
    
    } // eof execute

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_SC_POINTS_REDEEM_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Shopping Cart Redeem Points Module', 'MODULE_CONTENT_SC_POINTS_REDEEM_STATUS', 'True', 'Do you want to add the module to your shopping cart?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_SC_POINTS_REDEEM_CONTENT_WIDTH', '4', 'What width container should the content be shown in?', '6', '2', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_SC_POINTS_REDEEM_SORT_ORDER', '600', 'Sort order of display. Lowest is displayed first.', '6', '3', now())");
   }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_CONTENT_SC_POINTS_REDEEM_STATUS', 'MODULE_CONTENT_SC_POINTS_REDEEM_CONTENT_WIDTH', 'MODULE_CONTENT_SC_POINTS_REDEEM_SORT_ORDER');
    }
  }
